// bab.js

// Contains functions used for calculating the attack bonuses.
// Dependencies: general.js

function ParsedAdd(bMelee)
{
    // Calculates an attack bonus compatible with the style in the phb.
    // Parses the BAB field for mulitiple attacks, and adds additional
    // modifiers to each attack.
    // Calculates Melee AB if bMelee is true, otherwise, calculates the
    // ranged AB.
    if (document.all.disableAutoCalc != undefined)
        if (document.all.disableAutoCalc.value == 1)
            return;
    
    var myTotal, myBase, myAb, mySize, myMisc, myMsg;
    if (bMelee)
    {
        myTotal = document.all.MBAB;
        myBase = document.all.MABBase;
        myAb = document.all.MABStr;
        mySize = document.all.MABSize;
        myMisc = document.all.MABMisc;
        myMsg = "melee";
    }
    else
    {
        myTotal = document.all.RBAB;
        myBase = document.all.RABBase;
        myAb = document.all.RABDex;
        mySize = document.all.RABSize;
        myMisc = document.all.RABMisc;
        myMsg = "ranged";
    }
    
    var myString = new String(myBase.value);
    var myStringList = myString.split("/");
    var myRetList = new Array();
    for (var i in myStringList)
        myRetList[i] = Add(myStringList[i], myAb.value, mySize.value, myMisc.value);
    var myRetString = myRetList.join("/");
    myTotal.value = myRetString;
    
    window.status = "Recalculated " + myMsg + " attack bonus.";
}