// imp_d20Standard.js

// dependencies: general.js

var nFeatsLine, nSkillLine, nEquipLine, nSpellLine;

function d20Imp()
{
    var str = "This command will attempt to load character data from a standard d20 stablock. If you're importing over existing data, you should save your data before you continue.\n\nContinue with import?";
    if (!confirm(str))
        return;

    nFeatsLine = 0;
    nSkillLine = 0;
    nEquipLine = 0;
    nSpellLine = 0;
    
    // Get the text that is to be parsed.
    var toParse = window.showModalDialog(
        "./3ED&D General Extended/d20StdImpPrompt.html",
        "",
        "dialogHeight: 325px; dialogWidth: 500px; help: no; status: no;");

    if ((toParse == undefined) || (toParse.length == 0))
        return;
    
    // Split the lines.
    var lines = toParse.split("\r\n");
    var nPos, temp;
    
    try
    {
        nHeaderPos = lines[0].search(": ");
        if (nHeaderPos != -1)
        {
            GetNamesEtc(lines[0].substring(0, nHeaderPos));
            lines[0] = lines[0].substr(nHeaderPos + 2);
        }

        // Enumerate the remaining properties for Line 1.
        L1Enum(lines[0]);
        
        // Enumerate all the remaining lines.
        EnumRemaining(lines);
    }
    catch(e)
    {
        if (e.description)
        {
            alert("An unhandled error occured during the import process. Import Aborted.");
            if (__DEBUG__)
                throw e;
        }
        else
            alert("Import was aborted due to an error.\n\nThe following error was returned: " + e);
    }
    if (document.all.disableAutoCalc.value != 1)
    {
        document.all.disableAutoCalc.value = 1;
        alert("AutoCalc is now off.\n\nThe AutoCalc features have been disabled to allow you to clean up the imported data without accidentally overwritting existing data. To turn the AutoCalc features back on, use the \"Disable AutoCalc Featuers\" command in the Template menu.");
    }
}

function GetNamesEtc(l)
{
    // Name
    nPos = l.search(", ");
    if (nPos == -1)
        return;
    document.all.Name.value = l.substring(0, nPos);
    l = l.substr(nPos + 2);

    // Gender
    nPos = l.search(" ");
    if (nPos == -1)
        return;
    document.all.Gender.value = l.substring(0, nPos);
    l = l.substr(nPos + 1);

    // Race
    nPos = l.search(/\) /); // Check for subrace.
    if (nPos == -1)
    {
        nPos = l.search(" ");
        if (nPos == -1)
            return;
        document.all.Race.value = l.substring(0, nPos);
        l = l.substr(nPos + 1);
    }
    else
    {
        document.all.Race.value = l.substring(0, nPos + 1);
        l = l.substr(nPos + 2);
    }
    
    // Class and Level
    ParseClassLevel(l);
}

function ParseClassLevel(str)
{
    var combos = str.split("/");
    var classes = new Array();
    var levels = new Array();
    for (var i = 0; i < combos.length; i++)
    {
        var firstDigit = combos[i].search(/\d/);
        if (firstDigit == -1)
            return;
        classes[i] = combos[i].substring(0, firstDigit);
        levels[i] = combos[i].substr(firstDigit);
    }
    document.all.Class.value = classes.join("/");
    document.all.Level.value = levels.join("/");
}

function L1Enum(lines)
{
    for(;;)
    {
        var nPos = lines.search("; ");
        if (nPos == -1)
            break;
        var text = lines.substring(0, nPos);
        lines = lines.substr(nPos + 2);
        if (text.length < 3)
            continue;
        switch (text.substring(0, 2))
        {
            case "hp":
                GetHP(text);
                break;
            case "In":
                GetInit(text);
                break;
            case "Sp":
                GetSpeed(text);
                break;
            case "AC":
                GetAC(text);
                break;
            case "Me":
                TryMelee(text);
                break;
            case "Ra":
                TryRanged(text);
                break;
            case "AL":
                GetAL(text);
                break;
            case "SV":
                GetSaves(text);
                break;
            case "SQ":
                GetQualities(text);
                break;
        }
    }
    // Should have the statblock now.
    GetAbilities(lines);
}

function GetHP(t)
{
    document.all.HP.value = t.substr(3);
}

function GetInit(t)
{
    if (t.substring(0, 4) != "Init")
        return;
    document.all.Init.value = t.substr(5);
}

function GetSpeed(t)
{
    if (t.substring(0, 3) != "Spd")
        return;
    document.all.Speed.value = t.substr(4);
}

function GetAC(t)
{
    var nPos = t.search(/\(/);
    if (nPos == -1)
        document.all.AC.value = t.substring(3);
    else
        document.all.AC.value = t.substring(3, nPos);
}

function TryMelee(t)
{
    if (t.substring(0, 5) != "Melee")
        return;
    // Drop the tag.
    t = t.substr(6);
    AddWeapon(t, 1);
}

function TryRanged(t)
{
    if (t.substring(0, 6) != "Ranged")
        return;
    // Drop the tag.
    t = t.substr(7);
    AddWeapon(t, 2);
}

function AddWeapon(t, i)
{
    // Get Weapon Name
    var nPos = t.search(/\ [\+\-]/);
    if (nPos == -1)
        return;
    document.all["Weapon" + i].value = t.substring(0, nPos);
    t = t.substr(nPos + 1); // Kill space
    // Get AB.
    nPos = t.search(/\(/);
    if (nPos == -1)
        return;
    document.all["Weapon" + i + "AB"].value =
        t.substring(0, nPos - 1); // Kill space
    t = t.substr(nPos + 1); // Kill the bracket
    // Check for crit.
    nPos = t.search("/crit ");
    if (nPos != -1)
        document.all["Weapon" + i + "Crit"].value =
            t.substring(nPos + 6, t.length - 1);
    document.all["Weapon" + i + "Damage"].value =
        t.substring(0, ((nPos == -1) ? t.length - 1 : nPos));
    return;
}

function GetAL(t)
{
    document.all.Alignment.value = t.substr(3);
}

function GetSaves(t)
{
    t = t.substr(3);
    t = t.split(", ");
    for (var i = 0; i < t.length; i++)
    {
        if (t[i].substring(0, 4) == "Fort")
            document.all.Fort.value = t[i].substr(5);
        else if (t[i].substring(0, 4) == "Will")
            document.all.Will.value = t[i].substr(5);
        else if (t[i].substring(0, 3) == "Ref")
            document.all.Reflex.value = t[i].substr(4);
    }
}

function GetAbilities(t)
{
    t = t.split(", ");
    document.all.Str.value = t[0].substr(4);
    document.all.Dex.value = t[1].substr(4);
    document.all.Con.value = t[2].substr(4);
    document.all.Int.value = t[3].substr(4);
    document.all.Wis.value = t[4].substr(4);
    document.all.Cha.value = parseInt(t[5].substr(4));
}

function GetQualities(t)
{
    t = t.substr(3);
    t = t.split(", ");
    for (var i = 0; i < t.length; i++)
    {
        GetFeat(t[i]);
    }
}

function GetFeat(t)
{
    if (++nFeatsLine > 24)
        return;
    document.all["Feat" + FormatNumber(nFeatsLine)].value = t;
}

function EnumRemaining(l)
{
    for (var i = 1; i < l.length; i++)
    {
        if (l[i].length < 3)
            continue;
        switch (l[i].substring(0, 2))
        {
            case "Sk":
                GetSkillsAndFeats(l[i]);
                break;
            case "Eq":
                GetEquipment(l[i]);
                break;
            default:
                CheckSpells(l[i]);
                break;
        }
    }
}

function GetSkillsAndFeats(t)
{
    if (t.substring(0, 16) != "Skills and Feats")
        return;
    t = t.substr(18);
    t = t.split("; ");
    GetSkills(t[0]);
    GetFeats(t[1]);
}

function GetSkills(t)
{
    t = t.split(", ");
    for (var i = 0; i < t.length; i++)
        GetSkill(t[i]);
}

function GetSkill(t)
{
    if (++nSkillLine > 35)
        return;
    var nPos = t.search(/[\+\-]/);
    if (nPos == -1)
        return;
    document.all["Skill" + FormatNumber(nSkillLine)].value =
        t.substring(0, nPos - 1);
    document.all["Skill" + FormatNumber(nSkillLine) + "Mod"].value =
        t.substr(nPos);
}

function GetFeats(t)
{
    t = t.substring(0, t.length - 1); // Kill the trailing period.
    t = t.split(", ");
    for (var i = 0; i < t.length; i++)
        GetFeat(t[i]);
}

function GetEquipment(t)
{
    t = t.substring(0, t.length - 1); // Kill the trailing period.
    t = t.split(", ");
    for (var i = 0; i < t.length; i++)
        AddEquip(t[i]);
}

function AddEquip(t)
{
    if (++nEquipLine > 35)
        return;
    document.all["Gear" + FormatNumber(nEquipLine)].value = t;
}

function CheckSpells(t)
{
    var nPos = t.search(": ");
    if (nPos == -1)
        return;
    if (!((t.substring(0, nPos).search("Spells Prepared") != -1)
        || (t.substring(0, nPos).search("Spells Known") != -1)
        || (t.substring(0, nPos).search("Domain Spell") != -1)))
        return;
    if (++nSpellLine > 50)
        return;
    document.all["Spell" + FormatNumber(nSpellLine)].value =
        t.substring(0, nPos);
    t = t.substr(nPos + 2);
    var levels = t.split("; ");
    for (var i = 0; i < levels.length; i++)
    {
        // Kill the leading X-- (double hyphen)
        // or x (note this is an en dash, NOT a hyphen).
        spells = levels[i].split(", ");
        for (var j = 0; j < spells.length; j++)
        {
            if (++nSpellLine > 50)
                return;
            document.all["Spell" + FormatNumber(nSpellLine)].value = "   " + spells[j];
        }
    }
}