// saves.js

// Functions used for calculating Saves.
// Dependencies: general.js

function CalcSave(strSave)
{
    // Recalculates the saving throw specified by strSave.
    // strSave should be the base name of the save input elements,
    // one of Fort, Reflex, Will.
    if (document.all.disableAutoCalc != undefined)
        if (document.all.disableAutoCalc.value == 1)
            return;

    var inTotal, myBase, myAbility, myMagic, myMisc, myTemp;
    inTotal = document.all[strSave];
    myBase = document.all[strSave + "Base"].value;
    myAbility = document.all[strSave + "Ability"].value;
    myMagic = document.all[strSave + "Magic"].value;
    myMisc = document.all[strSave + "Misc"].value;
    myTemp = document.all[strSave + "Temp"].value;
    inTotal.value = Add(myBase, myAbility, myMagic, myMisc, myTemp);
    
    window.status = "Recalculated " + GenerateSaveName(strSave) + " save.";
}

function GenerateSaveName(strSave)
{
    // Returns the full name of the abbreviated save.
    if (strSave == "Fort")
        return "Fortitude";
    return strSave;
}