// dynamic.js

// Functions for dynamic control of the content of the 3ED&D Spell Sheet
// template.

// Dependencies: Data.js, general.js

// Declare the needed globals.
myData = new CData();

function AddSpellSlot()
{
    var nNumSlots;
    if (isNaN(parseInt(document.all.NumSlots.value)))
        nNumSlots = 0;
    else
        nNumSlots = document.all.NumSlots.value;
    
    nNumSlots ++;
    document.all.NumSlots.value = nNumSlots;
    
    document.all.Content.innerHTML = document.all.Content.innerHTML
        + GenerateSlotHTML(nNumSlots);
}

function Restore()
{
    var nNumSlots;
    if (isNaN(parseInt(document.all.NumSlots.value)))
        nNumSlots = 0;
    else
        nNumSlots = document.all.NumSlots.value;

    try
    {
        for (var i = 0; i < nNumSlots; i++)
        {
            document.all.Content.innerHTML = document.all.Content.innerHTML
                + GenerateSlotHTML(i + 1);
        }
        Populate();
    }
    catch (e)
    {
        if (e.description)
        {
            alert("An unhandled error occured while loading. Process aborted.");
            if (__DEBUG__)
                throw e;
        }
        else
            alert("An error occurred during loading: " + e + "\n\nProcess aborted.");
    }
}

function GenerateSlotHTML(nIndex)
{
    // Note the width=1 cells. Width is placed as a dummy value, specifying the
    // cells are to be as small as possible. They will be expanded to fit the
    // text. Important is to use non-breaking spaces (&nbsp;) instead of normal
    // spaces if more than one word in title to avoid word-wrapping.
    var t;
    var n = FormatNumber(nIndex);
    t = "<TABLE cellspacing=0><TR>";
    t += "<TD colspan=2><TABLE cellspacing=0 class=nv><TR><TD width=1>Spell&nbsp;Name:</TD><TD><INPUT type=text class=Sp name=SpellName" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "<TD><TABLE cellspacing=0 class=nv><TR><TD width=1>Page&nbsp;Ref:</TD><TD><INPUT type=text class=Sm name=SpellRef" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "<TD width=28 rowspan=2 valign=top><A onClick=\"MoveUp(this)\" name=" + n + "><IMG src=\"./3ED&D Spell Sheet/up.jpg\" border=0 alt=\"Move spell up one slot\" onMouseOver=\"OverUp(this)\" onMouseOut=\"OutUp(this)\"></A></TD>";
    t += "</TR><TR>";
    t += "<TD width=\"40%\"><TABLE cellspacing=0 class=nv><TR><TD width=1>School:</TD><TD><INPUT type=text class=Sm name=SpellSchool" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "<TD width=\"35%\"><TABLE cellspacing=0 class=nv><TR><TD width=1>Level:</TD><TD><INPUT type=text class=Sm name=SpellLevel" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "<TD width=\"25%\"><TABLE cellspacing=0 class=nv><TR><TD width=1>Cast&nbsp;Time:</TD><TD><INPUT type=text class=Sm name=SpellTime" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "</TR><TR>";
    t += "<TD><TABLE cellspacing=0 class=nv><TR><TD width=1>Duration:</TD><TD><INPUT type=text class=Sm name=SpellDuration" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "<TD><TABLE cellspacing=0 class=nv><TR><TD width=1>Range:</TD><TD><INPUT type=text class=Sm name=SpellRange" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "<TD><TABLE cellspacing=0 class=nv><TR><TD width=1>Compnt:</TD><TD><INPUT type=text class=Sm name=SpellComponents" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "<TD width=28 rowspan=2 valign=bottom><A onClick=\"MoveDown(this)\" name=" + n + "><IMG src=\"./3ED&D Spell Sheet/down.jpg\" border=0 alt=\"Move spell down one slot\" onMouseOver=\"OverDown(this)\" onMouseOut=\"OutDown(this)\"></A></TD>";
    t += "</TR><TR>";
    t += "<TD colspan=3><TABLE cellspacing=0 class=nv><TR><TD width=1>Other:</TD><TD><INPUT type=text class=Sm name=SpellOther" + n + " onChange=\"UpdateData(this)\"></TD></TR></TABLE></TD>";
    t += "</TR></TABLE><BR>&nbsp;";
    return t;
}

function Populate()
{
    // Called to populate all the fields with the data stored in the
    // CodedData input.
     myData.CreateFromDataString(document.all.CodedData.value);
}

function UpdateData(inText)
{
    // Update the CodedData input so all the info can be saved.
    myData.SetValue(inText.name, inText.value);
    document.all.CodedData.value = myData.GenerateDataString();
}
